/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

package com.sunlabs.archsim.fleet.ships.tokenaccumulator;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.fleet.common.Data;
import com.sunlabs.archsim.fleet.common.OutputFunction;
import com.sunlabs.archsim.globals.Globals;

/** Vacuous function used to acknowldge that the action has fired */ 
class AckFunction extends OutputFunction {

	/** Global settings */
	protected Globals globals= Globals.getInstance();
	
	public AckFunction() {
		this("AckFunction");
	}
	
        /**
         * Calls the superclass constructor and sets the delay for the function.
         */
	public AckFunction(String name) {
		super(name);
		Integer fDelay= globals.intValue(TokenAccumulatorDefaults.ACCUMULATOR_ACK_DELAY);
		functionDelay= (fDelay != null)
				? new Delay(fDelay.intValue())
				: TokenAccumulatorDefaults.ACCUMULATOR_ACK_DELAY_DEF;
	}
	
        /**
         * Acknowledges incoming data, whether it is valid or not.
         *
         * @return      a valid acknowledgement token.
         */
	public Data value() {
		return new Data(true);
	} // value
	
} // AckFunction